/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: USART2.c
* ߲		: IAR EWAAVR 2.28a/3.10c
* 			: $Revision: 1.3 $
* t			: $Date: 17. mars 2004 14:47:16 $
* XV		: $Author: ltwa $
*
* xEҰ		: avr@atmel.com
*
* x޲	: SPIUSARTS޲gp\
*				  ATmega8pɏĂ܂B
*
* pLq		: AVR303 - SPI-UART
*
// 			: Andy Gayne. avr@gayne.co.uk   www.gd-technik.com
// 			: 荞ݐUARTpٰ
****************************************************************************/

/* Includes */
#include "allheaders.h"

/* ÓIϐ */
static unsigned char USART_RxBuf[USART_RX_BUFFER_SIZE];
static volatile unsigned char USART_RxHead;
static volatile unsigned char USART_RxTail;
static unsigned char USART_TxBuf[USART_TX_BUFFER_SIZE];
static volatile unsigned char USART_TxHead;
static volatile unsigned char USART_TxTail;

/* USART */
void USART_Init( unsigned int baudrate )
{
	unsigned char x;

	UBRRH = (unsigned char) (baudrate>>8);		// ްڰĐݒ
	UBRRL = (unsigned char) baudrate;

	/* M荞݁AMAM */
	UCSRB = ( ( 1 << RXCIE ) | ( 1 << RXEN ) | ( 1 << TXEN ) );

	/* 8ޯ ްAèȂA1~ޯĂɐݒ */
	UCSRC = (1<<URSEL)|(0<<USBS)|(1<<UCSZ1)|(1<<UCSZ0);
	
	/* Mޯ̧ */
	x = 0;

	USART_RxTail = x;	// Mޯ̧ǂݍ݈ʒuwq
	USART_RxHead = x;	// Mޯ̧݈ʒuwq
	USART_TxTail = x;	// Mޯ̧ǂݍ݈ʒuwq
	USART_TxHead = x;	// Mޯ̧݈ʒuwq
}

	/* 荞ݏ */

#pragma vector=USART_RXC_vect
__interrupt void USART_RX_interrupt( void )
{
	unsigned char data;
	unsigned char tmphead;

	data = UDR;						// Mްǂݍ
	tmphead = ( USART_RxHead + 1 ) & USART_RX_BUFFER_MASK;	// Mޯ̧݈ʒu擾
	USART_RxHead = tmphead;			// Mޯ̧݈ʒuwqXV

	if ( tmphead == USART_RxTail )	// ǂݏʒudŁA
	{
		/* ُ! Mޯ̧ */
	}

	USART_RxBuf[tmphead] = data;							// MްMޯ̧Ɋi[
}

#pragma vector=USART_UDRE_vect
__interrupt void USART_TX_interrupt( void )
{
	unsigned char tmptail;

	if ( USART_TxHead != USART_TxTail )	// Mޯ̧ްLŁA
	{
		tmptail = ( USART_TxTail + 1 ) & USART_TX_BUFFER_MASK;	// Mޯ̧ǂݍ݈ʒu擾
		USART_TxTail = tmptail;				// Mޯ̧ǂݍ݈ʒuwqXV

		UDR = USART_TxBuf[tmptail];			// Mް
	}
	else								// Mޯ̧ްȂŁA
	{
		UCSRB &= ~(1<<UDRIE);			// Mް ڼ޽(UDRE)荞݋֎~
	}
}

	/* ǂݏ֐  */

unsigned char USART_Receive( void )
{
	unsigned char tmptail;

	while ( USART_RxHead == USART_RxTail );		// Mޯ̧őҋ@

	tmptail = ( USART_RxTail + 1 ) & USART_RX_BUFFER_MASK;	// Mޯ̧ǂݍ݈ʒu擾
	USART_RxTail = tmptail;			// Mޯ̧ǂݍ݈ʒuwqXV

	return USART_RxBuf[tmptail];	// ޯ̧̎MlŕA
}

void USART_Transmit( unsigned char data )
{
	unsigned char tmphead;

	tmphead = ( USART_TxHead + 1 ) & USART_TX_BUFFER_MASK;	// Mޯ̧݈ʒu擾
	while ( tmphead == USART_TxTail );		// Mޯ̧󂫂܂őҋ@

	USART_TxBuf[tmphead] = data;			// Mޯ̧ްi[
	USART_TxHead = tmphead;					// Mޯ̧݈ʒuwqXV

	UCSRB |= (1<<UDRIE);					// Mް ڼ޽(UDRE)荞݋
}

unsigned char DataInReceiveBuffer( void )
{
	return ( USART_RxHead != USART_RxTail );	// Mޯ̧ްL(1)(0)ŕA
}
